// ComUser.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

int main(int argc, char* argv[])
{
	HRESULT			hr;
	long			count;
	int				i;
	BSTR			bstrText;
	ISensorReader	*pISensorReader = NULL;
	wchar_t			buf[100];
	#define			MAX_IP_STR_LEN	(3*4+3)
	wchar_t			ip[MAX_IP_STR_LEN + 1];
	
	if (FAILED(::CoInitialize(NULL)))
		return -1;

	hr = ::CoCreateInstance(
			__uuidof(SensorReader), 
			NULL, 
			CLSCTX_INPROC_SERVER, 
			__uuidof(ISensorReader), 
			(void **)&pISensorReader);

	printf("Enter Poseidon IP address: ");

	wscanf(L"%ls", buf);
	wcsncpy(ip, buf, MAX_IP_STR_LEN);

	printf("Connecting[%ls]... \n", ip);


	if(!FAILED(hr)) 
	{
		hr = pISensorReader->put_DeviceIpAddress(ip);
		hr = pISensorReader->readDataFromDevice();
		hr = pISensorReader->get_Count(&count);
		
		printf("\nNumber of sensors = %d\n", count);

		for (i=1; i <= count; i++)
		{
			hr = pISensorReader->get_Item(i, &bstrText);
			printf("Sensor %d = %ls\n", i, bstrText);
		}

		pISensorReader->Release();

	}
	else
	{
		printf("Error\n");
	}	

	::CoUninitialize();

	return 0;
}

